/**
 **	File ......... Scope.h
 **	Published ....  2004-05-17
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _SCOPE_H
#define _SCOPE_H

#include "Sequence.h"


class Scope : public Sequence
{
public:
	Scope();
	Scope(token_v &);
	~Scope();

	void Add(Sequence *p) { m_sts.push_back(p); }
	void Display();

	bool Trail();
	void AddTrail(token_v &);
	std::string GetTrail();
	sequence_v::iterator ScopeBegin() { return m_sts.begin(); }
	sequence_v::iterator ScopeEnd() { return m_sts.end(); }

private:
	sequence_v m_sts;
	token_v m_trail;
};




#endif // _SCOPE_H
